
import javafx.application.Application;
import javafx.geometry.Insets;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.layout.FlowPane;
import javafx.stage.Stage;

public class FlowPaneDemo extends Application {
    @Override
    public void start(Stage stage) {
        FlowPane flowPane = new FlowPane(8, 4);

        flowPane.setPrefSize(400, 300);

        // センタリングでレイアウト
        flowPane.setAlignment(Pos.CENTER);

        // 上下に12、左右に24のパディングを設定
        flowPane.setPadding(new Insets(12, 24, 12, 24));

        Button button0 = new Button("Button0");
        FlowPane.setMargin(button0, new Insets(20, 20, 20, 20));
        flowPane.getChildren().add(button0);

        for (int i = 1; i < 10; i++) {
            Button button = new Button("Button" + i);
            flowPane.getChildren().add(button);
        }

        Scene scene = new Scene(flowPane);

        stage.setTitle("FlowPane Demo");
        stage.setScene(scene);
        stage.show();
    }

    public static void main(String[] args) {
        launch(args);
    }
}
