
import javafx.application.Application;
import javafx.geometry.Insets;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.layout.HBox;
import javafx.scene.layout.Priority;
import javafx.stage.Stage;

public class HBoxDemo extends Application {

    @Override
    public void start(Stage stage) {
        HBox hbox = new HBox(8);
        hbox.setPrefSize(400, 300);
        hbox.setPadding(new Insets(12));
        
        // 垂直方向に伸長する
        hbox.setFillHeight(true);

        Button button0 = new Button("Button0");
        // 最大サイズをdoubleの最大値に設定しておく
        // これでどこまでも伸長する
        button0.setMaxSize(Double.MAX_VALUE, Double.MAX_VALUE);
        // 余った領域があれば常に伸長する
        HBox.setHgrow(button0, Priority.ALWAYS);
        hbox.getChildren().add(button0);

        for (int i = 1; i < 4; i++) {
            Button button = new Button("Button" + i);
            button.setMaxSize(Double.MAX_VALUE, Double.MAX_VALUE);
            hbox.getChildren().add(button);
        }

        Scene scene = new Scene(hbox);

        stage.setTitle("HBox Demo");
        stage.setScene(scene);
        stage.show();
    }

    public static void main(String[] args) {
        launch(args);
    }
}
