
import javafx.application.Application;
import javafx.geometry.Insets;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.layout.Priority;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;

public class VBoxDemo extends Application {

    @Override
    public void start(Stage stage) {
        VBox vbox = new VBox(8);
        vbox.setPrefSize(400, 300);
        vbox.setPadding(new Insets(12));
        
        // 水平方向に伸長する
        vbox.setFillWidth(true);

        Button button0 = new Button("Button0");
        // 最大サイズをdoubleの最大値に設定しておく
        // これでどこまでも伸長する
        button0.setMaxSize(Double.MAX_VALUE, Double.MAX_VALUE);
        // 余った領域があれば常に伸長する
        VBox.setVgrow(button0, Priority.ALWAYS);
        vbox.getChildren().add(button0);

        for (int i = 1; i < 4; i++) {
            Button button = new Button("Button" + i);
            button.setMaxSize(Double.MAX_VALUE, Double.MAX_VALUE);
            vbox.getChildren().add(button);
        }

        Scene scene = new Scene(vbox);

        stage.setTitle("VBox Demo");
        stage.setScene(scene);
        stage.show();
    }

    public static void main(String[] args) {
        launch(args);
    }
}
